<template>
	<view class="uni-page-modal-3018-2">
		<view class="view-content">
			<!-- 表头样式 -->
			<OIForm ref="refBaseForm" class="v-headStyle" :form="head_styledef.form" :focusId="focusFieldId"
				@click="onClick" @focus="ontap" @change="onEnterChange" @click-prefix="classAttr_extButton"
				@click-suffix="classAttr_extButton"></OIForm>

		</view>
		<view class="view-bottom">
			<view class="uni-padding-wrap" v-if="dropdownBtns.length>0">
				<view class="uni-btn-v">
					<a @tap="clickDropdownBtns">
						<Icon class="mobox-normal-more" />
					</a>
				</view>
			</view>
			<button type="default" @tap="sava" class="btn_add" v-if="dropdownBtns.length==0 && btnName != ''"
				:class="saving?'btn_disabled':''" :disabled="saving">{{btnName}}</button>
			<button type="default" @tap="cancel"
				:class="(dropdownBtns.length> 0 || btnName != '')?'btn_cancel':'btn_cancel2'">{{translateSys('cancel')}}</button>

		</view>
		<!-- 普通弹窗 top bottom center left right -->
		<view>
			<uni-popup class="view-popup" ref="popup" background-color="#fff" @change="popupChange">
				<view class="popup-header">{{check_list.title}}</view>
				<view class="popup-content" :class="{ 'popup-height': popupType === 'left' || popupType === 'right' }"
					:style="{'width':check_list.width?check_list.width+'px':'375rpx','height':check_list.height?check_list.height+'px':popupType =='center'?'60vh':'88vh'}">
					<view class="popup-cont"
						:style="{'height':check_list.height?check_list.height-45+'px':popupType =='center'?'50vh':'80vh'}">
						<view class="view_popup_CheckList" v-for="(item,index) in check_list.items">
							<checkbox-group class="check_list" @change="checkChange" :data-ischeck="item.check"
								:data-index="index" :style="{'margin-left': '10rpx'}">
								<label>
									<checkbox :value="item.check" :checked="item.check" />
									<text>{{item.name}}</text>
								</label>
							</checkbox-group>
						</view>
					</view>
					<view class="popup-footer">
						<button type="default" @tap="popup_sava" class="btn_popup_add">{{translateSys('ok')}}</button>
						<button type="default" @tap="popup_cancel"
							class="btn_popup_cancel">{{translateSys('cancel')}}</button>
					</view>
				</view>
			</uni-popup>
		</view>
	</view>
</template>

<script>
	import Base64 from '../../components/js-base64/base64.js'
	import utils from "@/js/utils.js"
	import dayjs from "dayjs";
	import OIForm from '@/components/oi-form/index.vue'
	import {
		appGetInfo,
		dictGetInfo
	} from "@/api/mobox.js"
	import {
		getUIStyleInfo,
		runCustomEvent,
		dataObjCreate
	} from "@/api/data.js"

	export default {
		modules: {
			Base64,
		},
		components: {
			OIForm,
		},
		data() {
			return {
				title: this.translateSys('add2'),
				btnName: "",
				param: {},
				edit_inital_event: "", //弹窗初始化事件ID
				edit_ok_event: "", //弹窗点击OK 触发事件ID
				edit_select_compose_event: "", //选择组成对象时调用
				edit_compose_cls_id: "",
				global_attr: [],
				refdatastore: [], //引用数据存储区// {attr:'G_PRJ_' + bindattr + '_ID', value:info.id}
				scanCodeVal: "",
				popupType: "center",
				check_list: {},
				popupParam: {},
				focusFieldId: "",
				focusOldFieldId: "",
				head_styledef: {
					form: {
						items: []
					}
				},
				after_ok: {},
				activity: null,
				receiver: null,
				intentFilter: null,
				content: '',
				saving: false
			};
		},
		onNavigationBarButtonTap(e) {
			if (e.index == 0) {
				const $this = this
				uni.scanCode({
					scanType: ["qrCode"],
					success: function(res) {

						if ($this.focusFieldId) {
							const items = $this.head_styledef.form.items || []
							for (let i in items) {
								const ele = items[i]
								if (ele.name == 'Input' || ele.name == 'InputNumber' || ele.name ==
									'Textarea') {
									if ($this.focusFieldId == ele.fieldId) {
										$this.onScanValue(ele, res.result)
										break;
									}
								} else if (ele.name == "Layout") {
									let curIndex = (ele.setting.colList || []).findIndex((col, index2,
										arr) => {
										return (col.name == 'Input' || col.name == 'InputNumber' || col
												.name == 'Textarea') && $this
											.focusFieldId == col.fieldId;
									})
									if (curIndex > -1) {
										let col = ele.setting.colList[curIndex]
										$this.onScanValue(col, res.result)
										break
									}
								}
							}
						}

					}
				})
			} else if (e.index == 1) {
				//刷新
				// uni.redirectTo({
				// 	url: '../modal/3018_2?param=' + JSON.stringify(this.param) +
				// 		"&titlename=" + this.title
				// });
				this.setData({
					edit_inital_event: "", //弹窗初始化事件ID
					edit_ok_event: "", //弹窗点击OK 触发事件ID
					edit_select_compose_event: "", //选择组成对象时调用
					edit_compose_cls_id: "",
					global_attr: [],
					refdatastore: [], //引用数据存储区// {attr:'G_PRJ_' + bindattr + '_ID', value:info.id}
					scanCodeVal: "",
					popupType: "center",
					check_list: {},
					focusFieldId: "",
					focusOldFieldId: "",
					head_styledef: {
						form: {
							items: []
						}
					},
					after_ok: {},
					activity: null,
					receiver: null,
					intentFilter: null,
					content: '',
					saving: false
				})
				this.loadData()
			}
		},
		onLoad(options) {
			// console.log(options);
			uni.setNavigationBarTitle({
				title: options.titlename
			}); //设置顶部标题 
			this.$data.param = JSON.parse(options.param);
			this.$data.title = this.$data.param.Add_BtnName ? this.$data.param.Add_BtnName : options
				.titlename; //设置按钮文字
			this.$data.btnName = this.$data.param.Add_BtnName || ""
			this.loadData(options.paramValue)
		},
		computed: {
			dropdownBtns() {
				const btns = this.head_styledef.button || [];
				return btns
			},
		},

		methods: {

			setData: function(obj) {
				let that = this;
				let keys = [];
				let val, data;

				Object.keys(obj).forEach(function(key) {
					keys = key.split(".");
					val = obj[key];
					data = that.$data;
					keys.forEach(function(key2, index) {
						if (index + 1 == keys.length) {
							that.$set(data, key2, val);
						} else {
							if (!data[key2]) {
								that.$set(data, key2, {});
							}
						}
						data = data[key2];
					});
				});
			},
			async loadData(paramValue) {

				//获取数据类的自定义表单参数
				await this.Head_UIStyleGetInfo(this.param.DataCls?.id, this.param.UI_Style?.ID);
				//传入参数值
				if (paramValue) {
					const attrs = paramValue.attrs || [];
					(this.$data.head_styledef?.form?.items || []).forEach(async (ele, index) => {
						if (ele.name != "Layout") {
							attrs.forEach(async (ele2, index2) => {
								if (ele.fieldId == ele2.name) {
									ele.value = ele2.value;
								}
							});
						} else {
							ele.setting.colList.forEach(async (col) => {
								if (col) {
									attrs.forEach(async (ele2,
										index2) => {
										if (col.fieldId == ele2.name) {
											col.value = ele2.value;
										}
									});
								}
							});
						}
					})
				}


			},
			async Head_UIStyleGetInfo(class_id, style_id) { //获取自定义表单样式
				var $this = this;
				var dataInfo = {
					class_id: class_id,
					ui_style_id: style_id,
				};
				try {
					const ret = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (ret.style_def) {
						//mobox2的style_def是json字符串
						styledef = ret.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!ret.style_def.includes('"')) styledef = Base64.decode(ret.style_def);
					}
					const styledefHead = styledef ? JSON.parse(styledef) : {};
					if (styledefHead?.form?.items) {
						for (let i in styledefHead.form.items) {
							const ele = styledefHead.form.items[i]
							if (ele.name != "Layout") {
								ele.show = true
								if (ele?.useDict) {
									//判断useDict是否使用字典
									await $this.DictGetInfo(ele.bind.dict,
										styledefHead.form.model,
										ele);
								} else {
									if (ele?.name === "Select") {
										const selections = ele?.selections || []
										//有默认值，显示默认值
										let itemName = ele.value || "";
										if (itemName) {
											styledefHead.form.model[ele.fieldId] = itemName;
										}
										ele.dict = selections.map((a) => {
											return {
												value: a.value,
												text: a.label
											}
										})
									}
								}
								if ($this.focusFieldId == "") {
									if (ele.name == 'Input' || ele.name ==
										'InputNumber') {
										$this.setData({
											focusFieldId: ele.fieldId
										})
									}
								}
							} else {
								for (let j in ele.setting.colList) {
									const col = ele.setting.colList[j]
									if (col) {
										col.show = true
										if (col?.useDict) {
											//判断useDict是否使用字典
											await $this.DictGetInfo(col.bind
												.dict,
												styledefHead.form
												.model, col);
										} else {
											if (col?.name === "Select") {
												const selections = col?.selections || []
												//有默认值，显示默认值
												let itemName = col.value || "";
												if (itemName) {
													styledefHead.form
														.model[col.fieldId] = itemName;
												}
												col.dict = selections.map((a) => {
													return {
														value: a.value,
														text: a.label
													}
												})
											}
										}
										if ($this.focusFieldId == "") {
											if (col.name == 'Input' || col
												.name ==
												'InputNumber') {
												$this.setData({
													focusFieldId: col
														.fieldId
												})
											}
										}
									}
								}
							}
						}

					}
					$this.setData({
						head_styledef: styledefHead
					})
					if ($this.head_styledef.event) {
						$this.head_styledef.event.forEach(async (a) => { //判断是否是初始化事件
							if (a.event_id == "initial") {
								await $this.loadInitEvent(a.scrip_id);
							} else if (a.event_id == 'after_ok') {
								$this.after_ok = {
									id: a.scrip_id,
									name: a.scrip_name
								};
							}
						});
					}
				} catch (ex) {
					// console.log(ex);
					console.log(JSON.stringify(ex), ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("error") + "1.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},
			async DictGetInfo(dict, formModel, formItem) { //Mobox3得到得到字典信息字典项列表
				try {
					var $this = this;
					var dataInfo = {
						dict_id: dict.id,
						dict_name: dict.name
					};

					const res = await dictGetInfo(dataInfo)
					var list = [];
					var itemName = '';
					(res.dict_item_list || []).forEach((item) => {
						if (item.is_default == '1')
							itemName = item.name
						list.push({
							text: item.value ? item.value : item.name,
							value: item.name,
						});
					});
					//有默认值，显示默认值
					if (itemName) {
						formItem.value = itemName;
						formModel[formItem.fieldId] = itemName;
					}
					formItem.dict = list;
				} catch (ex) {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr

					uni.showModal({
						title: this.translateSys("error") + "1.3",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});


				}
			},

			async loadInitEvent(eventid) {
				try {
					var $this = this;
					if (!eventid.includes('{')) eventid = '{' + eventid + '}';
					var dataInfo = {
						ed_type: 0,
						start_transaction: true,
						class_id: this.param.DataCls.id,
						event_id: eventid,
					};
					console.log(dataInfo);
					var data = await runCustomEvent(dataInfo)
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info : data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var i = 0; i < actionlist.length; i++) {
								var action = actionlist[i];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									$this.setFormValues(result)
								} else if (action.action_type == 'set_dlg_attr_show') {
									var result = action.value;
									$this.hideFormItems(result)
									// console.log($this.$data.head_styledef);
								} else if (action.action_type ==
									"set_dlg_current_edit_attr"
								) {
									if ($this
										.focusOldFieldId ==
										action.value) {
										$this.setData({
											focusFieldId: ""
										})
									} else {
										$this.setData({
											focusFieldId: $this
												.focusOldFieldId
										})
									}
									$this.$nextTick(() => {
										$this.setData({
											focusFieldId: action
												.value
										})
									});
								} else {
									uni.showModal({
										title: this.translateSys("tip"),
										content: this.translate(
												'execute_init_event_failed') +
											this.translateSys("full_stop") +
											this.translate('reason') + this
											.translateSys(
												"colon") +
											this.translateSys("quotation_mark_left") +
											action
											.action_type + this.translateSys(
												"quotation_mark_right") + this
											.translate('tip_action_unprocessed'),
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}
					}
				} catch (ex) {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("error") + "3",
						content: this.translate('execute_init_event_failed') +
							this.translateSys("full_stop") +
							this.translate('reason') + this.translateSys("colon") + tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},


			ontap(item) { //扫码功能
				// console.log("ontap",item);
				// 打开蓝牙适配器
				// uni.openBluetoothAdapter({
				//   success: function() {
				// 	// 开始搜索蓝牙设备
				// 	uni.startBluetoothDevicesDiscovery({
				// 	  success: function() {
				// 		// 监听找到新设备的事件
				// 		uni.onBluetoothDeviceFound(function(devices) {
				// 		  // 这里可以过滤出RFID芯片，连接并读取数据
				// 		  console.log(devices[0].deviceId);
				// 		})
				// 	  }
				// 	})
				//   }
				// });
				// 监听NFC功能是否可用
				// uni.getNFCAdapterState({
				//   success: function(res) {
				// 	console.log(res);
				//     if (res.errCode === 0) {
				//       // NFC功能可用，开始监听
				//       uni.onNFCStart((res) => {
				//         if (res.errCode === 0) {
				//           // 开始NFC标签检测
				//           uni.makeNFCReaderStart({
				//             success: function() {
				//               // 监听NFC标签
				//               uni.onNFCTagDiscovered(function(res) {
				// 										  console.log(res);
				//                 // 这里可以处理NFC标签数据
				//               })
				//             }
				//           })
				//         }
				//       })
				//     }
				//   }
				// })
				this.focusOldFieldId = item.fieldId
				getApp().onScan((result) => {
					console.log(result);
					// uni.hideKeyboard();
					this.onScanValue(item, result.decodedata)
				})
			},
			onScanValue(item, value) {
				const $this = this;
				//console.log("onScanValue", item);
				item.value = value
				let newVal = item.value 
				if (typeof item.value == "string") {
					newVal = item.value.trim()
				}
				if (newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					$this.head_styledef.form.model[attr] = newVal;
					var eventid = item.bind.onChangeEvent.id; //内容变化后事件
					if (eventid) {
						var obj_attr = this.head_styledef.form.model;
						// console.log(obj_attr);
						var req = Object.keys(obj_attr).map((a) => ({
							attr: a,
							value: obj_attr[a] || "",
						}));

						var info = {
							eventid: eventid,
							edtype: "0",
							projectid: '',
							rclsid: '',
							robjid: '',
							userlogin: '',
							clsid: this.$data.param.DataCls.id,
							objid: "",
							attr: req,
							dataJson: [],
						}
						this.DataObjRunCustomEvent(info, '');
					}
					//初始化，下个输入框focus属性
					var findd = false
					for (let i in $this.head_styledef.form.items) {
						const ele = $this.head_styledef.form.items[i]

						if (ele.name != "Layout") {
							if (ele.name == 'Input' || ele.name == 'InputNumber') {
								if (attr == ele.fieldId) {
									findd = true
								} else {
									if (findd) {
										$this.setData({
											focusFieldId: ele.fieldId
										})
										break
									}

								}

							}
						} else {
							if (findd) {
								let curIndex = ele.setting.colList.findIndex((col, index2, arr) => {
									return (col.name == 'Input' || col.name == 'InputNumber');
								})
								if (curIndex > -1) {
									$this.setData({
										focusFieldId: ele.setting.colList[curIndex]
											.fieldId
									})
									break
								}

							} else {
								let curIndex = ele.setting.colList.findIndex((col, index2, arr) => {
									return attr == col.fieldId;
								})
								if (curIndex > -1) {
									findd = true
									let curIndex2 = ele.setting.colList.findIndex((col, index2, arr) => {
										return (col.name == 'Input' || col.name ==
												'InputNumber') &&
											index2 >
											curIndex;
									})
									if (curIndex2 > -1) {
										$this.setData({
											focusFieldId: ele.setting.colList[curIndex].fieldId
										})
										break
									}
								}
							}

						}
					}

				}
			},
			onClick(item) {
				// console.log("onClick",item);
				this.focusFieldId = item.fieldId
			},
			onEnterChange(item) {
				let newVal = item.value
				if (typeof item.value == "string") {
					newVal = item.value.trim()
					if (!newVal)
						return
				}
				if (item.oldvalue != newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					this.head_styledef.form.model[attr] = newVal;
					var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
					if (onChangeEvent?.id) { //内容变化后事件
						this.onChange(onChangeEvent);
					}
				}

			},
			// 内容变化后事件
			async onChange(event) {
				var eventid = event?.id; //内容变化后事件
				if (eventid) {
					// self.event_no_sub = 1;
					var obj_attr = this.head_styledef.form.model;
					// console.log(obj_attr);
					var req = Object.keys(obj_attr).map((a) => ({
						attr: a,
						value: obj_attr[a] || "",
					}));
					var info = {
						eventid: eventid,
						edtype: "0",
						projectid: '',
						rclsid: '',
						robjid: '',
						userlogin: '',
						clsid: this.$data.param.DataCls.id,
						objid: "",
						attr: req,
						dataJson: []
					}
					this.DataObjRunCustomEvent(info);
				}

			},

			classAttr_extButton(item) {
				var onSuffixClickCallbackEvent = item.bind.onSuffixClickCallbackEvent; //后图标点击事件
				var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击回调

				if (!onSuffixClickCallbackEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_callback_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				if (!onSuffixClickEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_event_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				this.$data.popupType = 'right'
				// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
				this.$refs.popup.open(this.popupType);

				this.dataObjRunCustomEvent_Return(onSuffixClickEvent.id, '', onSuffixClickCallbackEvent.id,
					item);
			},
			popupChange(e) {
				console.log('当前模式：' + e.type + ',状态：' + e.show);
			},
			checkChange(e) { //弹框check选择
				// console.log(e.target.dataset);
				var index = e.target.dataset.index;
				var ischeck = e.target.dataset.ischeck;
				var data = this.$data.check_list.items;
				// this.$data.check_list.items=[];
				if (this.$data.check_list.multiple_choice == "0") { //判断时单选还是多选
					for (var i in data) {
						data[i].check = false;
					}
				}
				data[index].check = ischeck ? false : true;
				this.$data.check_list.items = data;

			},
			popup_cancel(e) { //弹框取消
				this.$refs.popup.close();
			},
			popup_sava(e) { //弹框确定
				var $this = this;
				var items = $this.$data.check_list.items;
				var data = [];
				var name = "";
				for (var i = 0; i < items.length; i++) {
					if (items[i].check == true) {
						if (name)
							name += ';';
						name += items[i].name;
						data.push({
							id: items[i].id,
							name: items[i].name
						});
					}
				}
				if (!$this.$data.popupParam) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: "popupParam为空！",
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				if (data.length == 0) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("tip_no_select_data"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				var callback_eventid = $this.$data.popupParam.button_callback.trim();
				var info = {
					eventid: callback_eventid,
					edtype: "0",
					projectid: '',
					rclsid: '',
					robjid: '',
					userlogin: '',
					clsid: $this.$data.param.DataCls.id,
					objid: "",
					attr: $this.$data.popupParam.req,
					dataJson: data
				}
				$this.DataObjRunCustomEvent(info, $this.$data.popupParam.data_attr);
				this.$refs.popup.close();
			},

			async DataObjRunCustomEvent(info, data_attr) {
				var $this = this;
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: this.$data.param.DataCls.id, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: this.translateSys('add2'),
					master: {
						cls_id: this.$data.param.DataCls.id, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				if (data_attr) {
					enviroment.edit_dlg = {
						type: 'small', //小窗口
						class_id: this.$data.param.DataCls.id, //当前数据类id
					}
					if (data_attr) {
						enviroment.edit_dlg.form_control = { //所属的表单控件
							name: data_attr.Name, //字段属性
							text: data_attr.DispName, //显示文本
							group_name: data_attr.GroupName, //属性组
							type: data_attr.Type, //字段类型
							readonly: data_attr.ReadOnly, //是否只读
							button_img: data_attr.button_img, //引用按钮的图标
							button_tooltip: data_attr.button_tooltip //引用按钮的tooltip
						}
					}
				}

				// var dataInfo = {
				//     edtype: info.edtype, eventid: info.eventid, projectid: info.projectid.replace('{','').replace('}',''),
				//     rclsid: info.rclsid, robjid: info.robjid, userlogin: info.userlogin, clsid: info.clsid, objid: info.objid,
				//     attr: JSON.stringify(info.attr), extinfo: JSON.stringify(enviroment), inputparameter: "",
				// 	global_attr: JSON.stringify(this.$data.global_attr), dataJson:JSON.stringify(info.dataJson)
				// }
				enviroment = Base64.encode(JSON.stringify(enviroment)); //将字符串转换为base64编码
				var input_param = Base64.encode(JSON.stringify(info.attr)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify(this.$data.global_attr)); //将字符串转换为base64编码
				if (info.dataJson)
					info.dataJson = Base64.encode(JSON.stringify(info.dataJson)); //将字符串转换为base64编码
				var obj_attr = {};
				info.attr.forEach(item => {
					obj_attr[item.attr] = item.value;
				});
				if (!info.eventid.includes('{')) info.eventid = '{' + info.eventid + '}';
				var dataInfo = {
					ed_type: info.edtype,
					start_transaction: true,
					class_id: info.clsid,
					class_name: '',
					event_id: info.eventid,
					event_name: '',
					data_obj_id: info.objid,
					obj_attr: obj_attr,
					prj_id: info.projectid,
					ref_cls_id: info.rclsid,
					rel_obj_id: info.robjid,
					user_login: info.userlogin,
					data_json: info.dataJson,
					compose_info: '',
					ext_info: enviroment,
					global_attr: global_attr,
					input_param: input_param,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var i = 0; i < actionlist.length; i++) {
								var action = actionlist[i];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									$this.setFormValues(result)
								} else if (action.action_type == 'set_dlg_attr_show') {
									var result = action.value;
									$this.hideFormItems(result)
									// console.log($this.$data.head_styledef);
								} else if (action.action_type == 'set_global_attr') {
									$this.$data.global_attr = action.value || [];
								} else if (action.action_type ==
									"set_dlg_current_edit_attr"
								) {
									if ($this.focusOldFieldId == action.value) {
										$this.setData({
											focusFieldId: ""
										})
									} else {
										$this.setData({
											focusFieldId: $this.focusOldFieldId
										})
									}
									$this.$nextTick(() => {
										$this.setData({
											focusFieldId: action.value
										})
									});
								} else {
									uni.showModal({
										title: this.translateSys("tip"),
										content: this.translateSys(
												"quotation_mark_left") +
											action
											.action_type + this.translateSys(
												"quotation_mark_right") + this
											.translate(
												"tip_action_unprocessed"),
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}
						// var head_styledef = JSON.parse(JSON.stringify($this.head_styledef));
						// $this.head_styledef=[];
						// $this.head_styledef = head_styledef;
						console.log($this.head_styledef);

						if (data.result) {
							var result = data.result;
							for (var i = 0; i < result.length; i++) {
								for (var c = 0; c < $this.$data.head_styledef.form.items
									.length; c++) {
									var attr = $this.$data.head_styledef.form.items[c];
									//判断表单里是否有返回字段，没有就装载到model里，点击确定提交的时候带上这些数据
									if ($this.head_styledef.form.model[result[i].attr] ==
										undefined) {
										$this.head_styledef.form.model[result[i].attr] =
											result[i]
											.value;
									}
									//判断是否是栅格表单
									if (attr.name != 'Layout') {
										if (attr.fieldId == result[i].attr) {
											attr.value = '';
											attr.oldvalue = '';
											attr.value = result[i].value;
											attr.oldvalue = result[i].value;
											$this.head_styledef.form.model[attr.fieldId] =
												result[i]
												.value;
										}
									} else if (attr.name == 'Layout') {
										attr.setting.colList.forEach(col => {
											if (col) {
												if (col.fieldId == result[i].attr) {
													col.value = '';
													col.oldvalue = '';
													col.value = result[i].value;
													col.oldvalue = result[i].value;
													$this.head_styledef.form.model[col
															.fieldId] =
														result[i].value;
												}
											}
										});
									}
								}

								var length = 0;
								if (!$this.$data.refdatastore.filter(function(s) {
										return result[i].attr == s.attr
									}).length) {
									length = 1;
									$this.$data.refdatastore.push(result[i]);
								}
								if (length == 0) {
									for (var j = 0; j < $this.$data.refdatastore.length; j++) {
										if ($this.$data.refdatastore[j].attr == result[i]
											.attr) {
											$this.$data.refdatastore[j].value = result[i]
												.value;
										}
									}
								}
							}
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("error") + "3.1",
						content: exStr,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			dataObjRunCustomEvent_Return(eventid, data_attr, button_callback, item) {
				const $this = this
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: $this.param.DataCls.id, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: $this.translateSys('add2'),
					master: {
						cls_id: $this.param.DataCls.id, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				var obj_attr = $this.head_styledef.form.model;
				console.log(obj_attr);
				var req = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));
				if ($this.refdatastore.length > 0) {
					for (var i = 0; i < $this.refdatastore.length; i++) {
						if (!req.filter(function(s) {
								return $this.refdatastore[i].attr == s.name
							}).length) {
							req.push({
								'attr': $this.refdatastore[i].attr,
								'value': $this.refdatastore[i].value
							});
						}
					}
				}

				var extinfo = enviroment;
				extinfo.edit_dlg = {
					type: 'small', //小窗口
					class_id: $this.param.DataCls.id, //当前数据类id
				}
				extinfo = Base64.encode(JSON.stringify(extinfo)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify($this.global_attr)); //将字符串转换为base64编码
				var obj_attr = {};
				req.forEach(item2 => {
					obj_attr[item2.attr] = item2.value;
				});
				let input_param = Base64.encode(
					JSON.stringify(
						Object.keys(obj_attr).map((a) => ({
							attr: a,
							value: obj_attr[a] || "",
						}))
					)
				);

				if (!eventid.includes('{')) eventid = '{' + eventid + '}';
				var dataInfo = {
					ed_type: "0",
					start_transaction: true,
					class_id: $this.param.DataCls.id,
					class_name: '',
					event_id: eventid,
					event_name: '',
					data_obj_id: '',
					obj_attr: obj_attr,
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: [],
					compose_info: '',
					ext_info: extinfo,
					global_attr: global_attr,
					input_param: input_param,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if ($this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: $this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						} else uni.showModal({
							title: $this.translateSys("tip"),
							content: tip + ',' + $this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: $this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});

						if (data != "") {
							var actions = data.action;
							if (actions) {
								for (var i = 0; i < actions.length; i++) {
									var action = actions[i];
									console.log(action)
									var val = action.value;
									var enviroment = JSON.stringify(enviroment);

									if (action.action_type == 'open_panel') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys("quotation_mark_left") +
												action.action_type + $this.translateSys(
													"quotation_mark_right") +
												$this.translate("tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_select_userdlg') {
										var style = val.style;
										// style == 'user' ? '选择人员' : style == 'department' ? '选择部门' : style == 'role' ? '选择角色' : ''
										var param = {
											item: item,
											button_callback: button_callback,
											req: req,
											data_attr: data_attr
										}
										uni.navigateTo({
											url: '../selpsn/index?mulit=false&param=' +
												JSON
												.stringify(
													param),
											events: {
												AddPer(data, param) {
													// console.log(param);
													console.log(data);
													var callback_eventid = param
														.button_callback
														.trim();
													var info = {
														eventid: callback_eventid,
														edtype: "0",
														projectid: '',
														rclsid: '',
														robjid: '',
														userlogin: '',
														clsid: $this.$data.param
															.DataCls
															.id,
														objid: "",
														attr: param.req,
														inputparameter: data,
														dataJson: [],
													}
													$this.DataObjRunCustomEvent(info,
														param
														.data_attr);
												}
											}
										});
									} else if (action.action_type == 'open_data_query_dlg') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action
												.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_common_dlg') {

										if (val.common_dlg_id == 'check_list') {

											$this.setData({
												check_list: val.config
											})
											if (val.config.appear_style == 'sideslip') //判断是否是侧滑
												$this.setData({
													popupType: "right"
												})
											else
												$this.setData({
													popupType: "center"
												})
											// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
											$this.$refs.popup.open($this.popupType);
											var popupParam = {
												item: item,
												button_callback: button_callback,
												req: req,
												data_attr: data_attr
											}
											$this.setData({
												popupParam: popupParam
											})
										}
									} else if (action.action_type == 'open_project_query_dlg') {
										//console.log(action.value.select_range);
										//console.log(action.value.mulit_select);
										var priRel = '-1';
										if (action.value.select_range == '全部相关')
											priRel = '0';
										else if (action.value.select_range == '我负责的项目')
											priRel = '1';
										else if (action.value.select_range == '我创建的')
											priRel = '2';
										else if (action.value.select_range == '我参与的' || action
											.value
											.select_range == '我参加的')
											priRel = '3';
										else if (action.value.select_range == '我关注的')
											priRel = '4';
										else if (action.value.select_range == '我下属的项目')
											priRel = '5';
										var param_ = {
											item: item,
											button_callback: button_callback,
											req: req
										}
										uni.navigateTo({
											url: '../selPrj/index?relation=' + priRel +
												'&param=' +
												JSON.stringify(param_),
											events: {
												AddPer(data, param) {
													var attr = param.item.fieldId;
													$this.head_styledef.form.model[
															attr] =
														data[0].ID +
														';' + data[0].Name;

													// $this.$data.classAttrList[param.index].Attr[param.iindex].Value=data[0].Name;
													// $this.$data.classAttrList[param.index].Attr[param.iindex].ValID=data[0].ID+';'+data[0].Name;
													var callback_eventid = param
														.button_callback
														.trim();
													if (callback_eventid) {
														var info = {
															eventid: callback_eventid,
															edtype: "2",
															projectid: data[0].ID,
															rclsid: "",
															robjid: "",
															userlogin: "",
															clsid: $this.$data
																.param
																.DataCls.id,
															objid: "",
															attr: param.req,
															dataJson: [],
														}

														$this.DataObjRunCustomEvent(
															info);
													}
												}
											}
										});
									} else {
										uni.showModal({
											title: $this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed"),
											showCancel: false,
											confirmText: $this.translateSys('close')
										});
									}
								}
							}
						} else {
							uni.showModal({
								title: $this.translateSys('tip') + "5.2",
								content: $this.translateSys("quotation_mark_left") +
									"before_click_button" + $this.translateSys(
										"quotation_mark_right") + $this.translateSys(
										"comma") + 'event_id' + eventid,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: $this.translateSys('tip') + "5.1",
						content: exStr,
						showCancel: false,
						confirmText: $this.translateSys('close')
					});
				});
			},

			//确定
			sava() {
				if (this.after_ok?.id) { // 点击确定按钮后
					this.afterOK();
				} else {
					this.add();
				}

			},
			add() {
				const $this = this
				uni.showLoading({
					title: this.translateSys("loading"),
					mask: true
				});
				this.saving = true
				var obj_attr = this.head_styledef.form.model || [];
				console.log(obj_attr);
				// var req = Object.keys(obj_attr).map((a) => ({
				// 	name: a,
				// 	value: obj_attr[a] || "",
				// }));

				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: this.$data.param.DataCls.id, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: this.translateSys('add2'),
					master: {
						cls_id: this.$data.param.DataCls.id,
					}
				};
				enviroment = Base64.encode(JSON.stringify(enviroment)); //将字符串转换为base64编码

				// console.log(obj_attr);
				// var dataInfo={
				//     class_id: this.$data.param.DataCls.id, data_obj_id: '', masterclsid: '',
				//     req: JSON.stringify(req), upfile: JSON.stringify([]), post_data: JSON.stringify({}),
				//     compose: JSON.stringify([]), refdatastore: JSON.stringify([]), extinfo: JSON.stringify(enviroment), 
				// 	not_trigger_sys_event: ''
				// };
				var dataInfo = {
					class_id: this.$data.param.DataCls.id,
					class_name: '',
					master_cls_id: '',
					master_obj_id: '',
					creator: '',
					creator_name: '',
					not_trigger_event: '',
					update_exist: '',
					post_process: '',
					ext_info: enviroment,
					obj_attr: obj_attr
				};
				console.log(dataInfo);
				// return
				dataObjCreate(dataInfo).then(res => {
					uni.hideLoading();
					let data = res.lua_result
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						this.saving = false
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						else {

							uni.showToast({
								title: this.translate('create_success'),
								icon: "success",
								duration: 3000
							});
						}


						if (!this.$data.param.After_Btn_Not_Refresh) {
							//刷新
							uni.redirectTo({
								url: '../modal/3018_2?param=' + JSON.stringify(this.$data
										.param) +
									"&titlename=" + this.$data.title
							});
						} else {
							var actionlist = data.action;
							if (actionlist) {
								console.log(actionlist);
								for (var i = 0; i < actionlist.length; i++) {
									var action = actionlist[i];
									if (action.action_type == 'set_dlg_attr') {
										$this.setFormValues(action.value)
									} else if (action.action_type == 'set_dlg_attr_show') {
										var result = action.value;
										$this.hideFormItems(result)
									} else if (action.action_type ==
										"set_dlg_current_edit_attr"
									) {
										if ($this
											.focusOldFieldId ==
											action.value) {
											$this.setData({
												focusFieldId: ""
											})
										} else {
											$this.setData({
												focusFieldId: $this
													.focusOldFieldId
											})
										}
										$this.$nextTick(() => {
											$this.setData({
												focusFieldId: action
													.value
											})
										});
									}
								}
							}

						}
					}
					// this.class_attr_init();

					this.saving = false
				}).catch(ex => {
					this.saving = false

					uni.hideLoading();
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("tip"),
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			setFormValues(data) {
				const $this = this
				for (var i = 0; i < data.length; i++) {
					if (data[i].choice_list) {
						for (var c = 0; c < $this.head_styledef.form.items
							.length; c++) {
							var attr = $this.head_styledef.form.items[c];
							if (attr.name != 'Layout') {
								if (attr.fieldId == data[i].attr) {
									var dictItemList = [];
									for (var d in data[i].choice_list) {
										var val = data[i].choice_list[d];
										dictItemList.push({
											"CN_S_NAME": val,
											"CN_S_VALUE": val,
											"text": val,
											"value": val
										});
									}
									attr.dict = dictItemList;
								}
							} else if (attr.name == 'Layout') {
								attr.setting.colList.forEach(col => {
									if (col) {
										if (col.fieldId == data[
												i]
											.attr) {
											var dictItemList = [];
											for (var d in data[i]
													.choice_list) {
												var val = data[i]
													.choice_list[
														d];
												dictItemList.push({
													"CN_S_NAME": val,
													"CN_S_VALUE": val,
													"text": val,
													"value": val
												});
											}
											col.dict =
												dictItemList;
										}
									}
								});
							}

						}
					}
					for (var c = 0; c < $this.$data.head_styledef.form
						.items
						.length; c++) {
						var attr = $this.$data.head_styledef.form.items[c];
						// console.log(attr[j].Name+'=='+data[i].attr);
						//判断表单里是否有返回字段，没有就装载到model里，点击确定提交的时候带上这些数据
						if ($this.head_styledef.form.model[data[i]
								.attr] ==
							undefined) {
							$this.head_styledef.form.model[data[i]
									.attr] =
								data[i]
								.value;
						}
						//判断是否是栅格表单
						if (attr.name != 'Layout') {
							if (attr.fieldId == data[i].attr) {
								attr.value = '';
								attr.oldvalue = '';
								attr.value = data[i].value;
								attr.oldvalue = data[i].value;
								$this.head_styledef.form.model[attr
										.fieldId] =
									data[
										i].value;
							}
						} else if (attr.name == 'Layout') {
							attr.setting.colList.forEach(col => {
								if (col) {
									if (col.fieldId == data[i]
										.attr) {
										col.value = '';
										col.oldvalue = '';
										col.value = data[i]
											.value;
										col.oldvalue = data[i]
											.value;
										$this.head_styledef.form
											.model[
												col
												.fieldId] = data[
												i]
											.value;
									}
								}
							});
						}
					}
					var length = 0;
					if (!$this.$data.refdatastore.filter(function(s) {
							return data[i].attr == s.attr
						}).length) {
						length = 1;
						$this.$data.refdatastore.push(data[i]);
					}
					if (length == 0) {
						for (var j = 0; j < $this.$data.refdatastore
							.length; j++) {
							if ($this.$data.refdatastore[j].attr == data[
									i]
								.attr) {
								$this.$data.refdatastore[j].value = data[
										i]
									.value;
							}
						}
					}
				}

			},
			hideFormItems(data) {
				const $this = this
				data.forEach(async (attr, key) => {
					$this.$data.head_styledef.form.items
						.forEach(
							async (
								ele, index) => {
								//判断是否是栅格表单
								if (ele.name != 'Layout') {
									if (ele.fieldId == attr
										.attr) {
										ele.show = attr
											.show;
									}
								} else if (ele.name ==
									'Layout') {
									ele.setting.colList
										.forEach(
											col => {
												if (col) {
													if (col
														.fieldId ==
														attr
														.attr
													) {
														col.show =
															attr
															.show;
													}
												}
											});
								}
							});
				});
				var head_styledef = JSON.parse(JSON.stringify($this.$data
					.head_styledef));
				$this.$data.head_styledef = [];
				$this.$data.head_styledef = head_styledef;
			},
			afterOK() {
				this.saving = true
				const $this = this
				var obj_attr = this.head_styledef.form.model;
				// console.log(obj_attr);
				var input_param = {
					id: "",
					attrs: Object.keys(obj_attr).map((a) => ({
						attr: a,
						value: obj_attr[a],
					})),
				};
				if (!this.after_ok.id.includes('{')) this.after_ok.id = '{' + this.after_ok.id + '}';
				var dataInfo = {
					ed_type: "0",
					start_transaction: true,
					class_id: this.$data.param.DataCls.id,
					class_name: '',
					event_id: this.after_ok.id,
					event_name: '',
					data_obj_id: '',
					obj_attr: obj_attr,
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: '',
					compose_info: '',
					input_param: Base64.encode(JSON.stringify(input_param)),
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {

					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						this.saving = false
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						if (!this.$data.param.After_Btn_Not_Refresh) {
							//刷新
							uni.redirectTo({
								url: '../modal/3018_2?param=' + JSON.stringify(this.$data
										.param) +
									"&titlename=" + this.$data.title
							});
						} else {
							var actionlist = data.action;
							if (actionlist) {
								console.log(actionlist);
								for (var i = 0; i < actionlist.length; i++) {
									var action = actionlist[i];
									if (action.action_type == 'set_dlg_attr') {
										$this.setFormValues(action.value)
									} else if (action.action_type == 'set_dlg_attr_show') {
										var result = action.value;
										$this.hideFormItems(result)
									} else if (action.action_type ==
										"set_dlg_current_edit_attr"
									) {
										if ($this
											.focusOldFieldId ==
											action.value) {
											$this.setData({
												focusFieldId: ""
											})
										} else {
											$this.setData({
												focusFieldId: $this
													.focusOldFieldId
											})
										}
										$this.$nextTick(() => {
											$this.setData({
												focusFieldId: action
													.value
											})
										});
									}

								}
							}
						}
					}

					this.saving = false
				}).catch(ex => {
					// console.log(ex);
					this.saving = false
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys('tip') + "7.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			//点击按钮列表
			clickDropdownBtns() {
				var that = this
				var itemlist = [];
				this.dropdownBtns.forEach((btn) => {
					itemlist.push(btn.ShowName);
				});
				uni.showActionSheet({
					// title: '按钮列表',
					itemList: itemlist,
					success: (e) => {
						console.log(e.tapIndex);
						var btn = that.dropdownBtns[e.tapIndex];
						that.onButtonClicked(btn);
					}
				})
			},
			onButtonClicked(btn) {
				let enviroment = {
					button: "top",
					button_name: btn.ShowName,
					cls_id: btn.Cls_ID,
					function: "3018",
					master: {},
				};
				console.log("onBtnClick", btn);
				if (btn.FunCode == "Add") {
					if (btn.Edit_dlg.Model == "small") {
						this.showAddSmallDialog(btn, enviroment);
					} else {
						uni.showModal({
							title: this.translateSys("tip"),
							content: this.translateSys("unrealized"),
							showCancel: false,
							confirmText: this.translateSys('close')
						});
					}
				} else if (btn.FunCode == "TriggerEvent") {
					this.onTriggerEvent(btn, enviroment);
				} else {
					this.$Message.warning(this.$t("sys.unrealized"));
				}
			},
			onTriggerEvent(btn, enviroment) {
				const $this = this
				var obj_attr = this.head_styledef.form.model;
				// console.log(obj_attr);
				var input_param = {
					id: "",
					attrs: Object.keys(obj_attr).map((a) => ({
						attr: a,
						value: obj_attr[a],
					})),
				};

				var dataInfo = {
					ed_type: "0",
					start_transaction: true,
					class_id: btn.Cls_ID,
					class_name: '',
					event_id: btn.Event.ID,
					event_name: '',
					data_obj_id: '',
					obj_attr: obj_attr,
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: '',
					compose_info: '',
					input_param: '',
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						if (!this.$data.param.After_Btn_Not_Refresh) {
							//刷新
							uni.redirectTo({
								url: '../modal/3018_2?param=' + JSON.stringify(this.$data
										.param) +
									"&titlename=" + this.$data.title
							});
						} else {
							var actionlist = data.action;
							if (actionlist) {
								console.log(actionlist);
								for (var i = 0; i < actionlist.length; i++) {
									var action = actionlist[i];
									if (action.action_type == 'set_dlg_attr') {
										$this.setFormValues(action.value)
									} else if (action.action_type == 'set_dlg_attr_show') {
										var result = action.value;
										$this.hideFormItems(result)
									} else if (action.action_type ==
										"set_dlg_current_edit_attr"
									) {
										if ($this
											.focusOldFieldId ==
											action.value) {
											$this.setData({
												focusFieldId: ""
											})
										} else {
											$this.setData({
												focusFieldId: $this
													.focusOldFieldId
											})
										}
										$this.$nextTick(() => {
											$this.setData({
												focusFieldId: action
													.value
											})
										});
									}

								}
							}
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys('tip') + "7.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys("close")
					});
				});

			},
			//新增修改小窗口数据
			showAddSmallDialog(btn, enviroment) {
				var data = {
					Add_BtnName: btn.ShowName,
					EditDlgMode: btn.Edit_dlg.Model,
					clsid: btn.Cls_ID,
					cls_name: btn.Cls_Name,
					Edit_dlg: btn.Edit_dlg
				};
				const url = '../modal/3018?param=' + JSON.stringify(data) + "&titlename=" + btn.Edit_dlg
					.Name +
					"&type=addDataObj"
				var $this = this;
				uni.navigateTo({
					url: url,
					events: {
						// 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
						addDataObj: function(resData) {
							console.log(resData);
							//刷新
							uni.redirectTo({
								url: '../modal/3018_2?param=' + JSON.stringify(this
										.$data.param) +
									"&titlename=" + this.$data.title
							});

						},
					}
				});
			},

			cancel(e) { //取消
				uni.navigateBack({
					delta: 1 //返回层数，2则上上页
				});
			},
			translate(t) {
				if (typeof this.$t == "function") return this.$t(`page.${t}`)
				else return t;
			},
			translateSys(t) {
				if (typeof this.$t == "function") return this.$t(`sys.${t}`)
				else return t;
			},
		},
	};
</script>
<style>
	.popup-content {
		@include flex;

	}

	.popup-height {
		@include height;
		/* width: 200px; */
	}
</style>
<style lang="scss">
	.uni-page-modal-3018-2 {
		display: flex;
		height: calc(100vh - 30rpx);
		width: 720rpx;
		flex-direction: column !important;
		padding: 15rpx;

		.v-headStyle {
			/* border: 0.1rpx solid red; */
			/* line-height: 30rpx; */
			// padding: 5rpx 0;
			width: 98%;
		}

		.uni-forms-item {
			// border: 0.5px solid red;
			margin-bottom: 11rpx;
		}

		// .v-headStyle .form-item-span {
		// 	// border: 0.5px solid red;
		// 	padding: 7rpx 0;
		// 	color: #2d8cf0;
		// 	white-space: normal;
		// 	word-break: break-all;
		// 	display: inline-block;
		// 	// width: calc(100% - 100px);
		// }

		.input-wrapper {
			border: 1px solid #d5d5d5;
			width: 100%;
			display: flex;
			flex-direction: row;

			.uni-input {
				color: #2d8cf0;
				flex: 1;
				padding: 10rpx 8rpx;
				// height: 40rpx;
				// line-height: 40rpx;
			}

			.uni-icon {
				padding: 10rpx 5rpx;
				font-size: 32rpx;
				color: rgb(192, 196, 204);
			}
		}

		.check_rememberPwd,
		.input-switch {
			vertical-align: middle;
			margin-left: 10rpx
		}

		[nvue] uni-view {
			position: relative;
			border: 0 solid #000;
			box-sizing: border-box;
		}


		.uni-icon {
			/* border: 1px solid red; */
			width: 30rpx;
			font-family: uniicons;
			font-size: 40rpx;
			font-weight: 400;
			font-style: normal;
			/* width: 48rpx; */
			/* height: 48rpx; */
			/* line-height: 44rpx; */
			color: #2d8cf0;
			cursor: pointer;
			display: inline-block;
			vertical-align: middle;
		}

		.input-disabled {
			background-color: #f3f3f3 !important;
		}

		.view-content {
			display: flex;
			flex: 1;
			width: calc(100% - 30rpx);
			padding: 10rpx 15rpx;
			flex-direction: column;
			overflow-y: auto;

		}

		.view-bottom {
			// display: flex;
			// flex-direction: row;
			display: block;
			width: calc(100% - 30rpx);
			padding: 10rpx 15rpx 20rpx 15rpx;

			.btn_add {
				width: 45%;
				margin: 0 10rpx;
				// padding: 5rpx 10rpx;
				background: #27A6E1;
				border: none;
				color: #fff;
				font-size: 38rpx;
				float: left;
				display: inline-block;
			}

			.btn_disabled {
				background-color: #ddd;
				color: #888;
			}

			.btn_cancel {
				width: 45%;
				margin: 0 10rpx;
				background: #fff;
				border: none;
				//color: #000;
				font-size: 38rpx;
				float: right;
				display: inline-block;
			}

			.btn_cancel2 {
				width: 90%;
				margin: 0 10rpx;
				background: #fff;
				//	border: none;
				color: #000;
				font-size: 38rpx;
				float: right;
				display: inline-block;
			}

			.uni-padding-wrap {
				margin: 2rpx 0 0 10rpx;
				background-color: #98DAEA;
				width: 104rpx;
				height: 80rpx;
				text-align: center;
				border-radius: 54rpx;
				padding: 24rpx 0 0 0;
				float: right;
				display: inline-block;
			}

			.uni-padding-wrap a {
				font-size: 40rpx;
			}
		}




		.view-popup {
			position: relative;
		}

		.popup-content {
			// @include flex;
			align-items: center;
			justify-content: center;
			padding: 30rpx;
			background-color: #fff;
			/* height: 150px; */
			/* border: 1px solid red; */
		}

		.popup-cont {
			overflow-y: auto;
			/* border: 1px solid red; */
		}

		.popup-height {
			// @include height;
			/* width: 200px; */
		}

		.popup-header {
			font-size: 42rpx;
			font-weight: bold;
			margin: 20rpx 20rpx 0px 20rpx;
		}

		.view_popup_CheckList {
			margin-bottom: 20rpx;
		}

		.popup-footer {
			float: right;
			position: absolute;
			bottom: 10rpx;
			right: 20rpx;
		}

		button.btn_popup_add {
			width: 180rpx;
			margin-top: 50rpx;
			margin-right: 20rpx;
			padding: 15rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			/* float: left; */
			display: inline-block;
		}

		button.btn_popup_cancel {
			width: 180rpx;
			margin-top: 50rpx;
			padding: 15rpx;
			line-height: 1.5;
			// background: #27A6E1;
			// border: none;
			// color: #fff;
			background: #fff;
			color: #000;
			font-size: 38rpx;
			font-weight: bold;
			/* float: right; */
			display: inline-block;
		}

		#dv_select {
			display: inline-block;
			// width: 66%;
			background: #FFF;
			border-radius: 0 !important;
			color: #2d8cf0;
			/* padding: 10rpx 8rpx 12rpx; */
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 0rpx;
			/* vertical-align: 10px; */
			vertical-align: middle;
		}

		#dv_select .uni-select {
			border: 1px solid #ccc;
			border-radius: 0 !important;
			color: #2d8cf0;
		}

		#dv_select .uni-select__input-text {
			color: #2d8cf0;
		}

		.panel_title {
			font-size: 38rpx;
			background-color: #27A6E1;
			line-height: 80rpx;
			color: #fff;
			text-align: center;
			font-weight: bold;
		}

		.v-panel {
			min-height: 788rpx;
		}

		.v-panellist {
			border: 4rpx solid #aaa;
			border-radius: 10rpx;
			margin: 10rpx 20rpx 0rpx 20rpx;
		}

		.v-paneldel {
			text-align: right;
		}

		.panel_del {
			font-size: 44rpx;
			text-decoration: initial;
			margin-top: 10rpx;
			margin-right: 20rpx;
		}

		.class_attr_body .form-group {
			margin: 20rpx 30rpx;
			/* margin-left: -12px;
    margin-right: -12px; */
		}

		.subclass_attr_body .form-group {
			margin: 20rpx 10rpx;
			/* margin-left: -12px;
    margin-right: -12px; */
		}

		.form-group>label[class*="col-"] {
			margin-bottom: 8rpx;
			font-size: 32rpx;
		}

		.form-group label {
			vertical-align: middle;
			line-height: 60rpx;
		}

		.tx_title2 {
			font-size: 32rpx;
			text-align: right;
			display: inline-block;
			vertical-align: -2px;
		}

		.attr_field {
			display: inline-block;
			vertical-align: middle;
			margin-left: 8px;
			/* width: 71%; */
		}

		.text-right2 {
			margin: 0;
			vertical-align: -4px;
			margin-left: 9px;
			float: none;
			font-size: 44rpx;
			display: inline-block;
		}

		input::-webkit-input-placeholder {
			font-size: 12rpx;
		}

		.v-panel input {
			border: 1px solid #d5d5d5;
			width: 98%;
			height: 52rpx;
			background: #FFF;
			border-radius: 0 !important;
			color: #046db3;
			padding: 10rpx 8rpx 12rpx;
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 4rpx;
		}

		.date_iput {
			/* border: 1px solid #d5d5d5; */
			/* width: 98%; */
			height: 62rpx;
			background: #FFF;
			border-radius: 0 !important;
			color: #046db3;
			padding: 10rpx 8rpx 4rpx;
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
		}

		.dv_input {
			display: inline-block;
			width: 65%;
			/* line-height: 22rpx; */
		}




		.demo-uni-row {
			margin-bottom: 0px;
			display: block;
		}

		::v-deep .uni-row {
			margin-bottom: 0px;
		}

		.view-tabpage ::v-deep .uni-row {
			margin-bottom: 5px;
		}

		.demo-uni-col {
			height: 36px;
			border-radius: 5px;
		}

		.text {
			font-size: 12px;
			color: #666;
			margin-top: 5px;
		}
	}
</style>